"""This document is intended to allow the user to set up 16 presets for use with the MonoLink component used in b993 and forward of Monomodular.  It defines 16 different user banks that can be switched on-the-fly for use with various monome applications.  Its default configuration is set up for several popular applications that are currently in circulation."""
"""To use this file, rename the variable for each preset to your preference.  When switching 'channels' on the MonoLink client in Monomodular, the Monolink component will automatically switch its settings to match the user preferences defined by the channel statements in this document"""

MONOLINK_ENABLE = True

"""default configuration"""
CHANNEL1_DESC = 'default'
CHANNEL1_PREFIX = '/MonoLink'
CHANNEL1_INPORT = '10092'
CHANNEL1_OUTPORT = '10091'
CHANNEL1_FORMAT = 0

"""molar configuration"""
CHANNEL2_DESC = 'molar'
CHANNEL2_PREFIX = '/40h'
CHANNEL2_INPORT = '8080'
CHANNEL2_OUTPORT = '8000'
CHANNEL2_FORMAT = 1

"""polygome configuration"""
CHANNEL3_DESC = 'gome'
CHANNEL3_PREFIX = '/gome'
CHANNEL3_INPORT = '10092'
CHANNEL3_OUTPORT = '9001'
CHANNEL3_FORMAT = 0

"""pages configuration"""
CHANNEL4_DESC = 'pages'
CHANNEL4_PREFIX = '/40h'
CHANNEL4_INPORT = '8080'
CHANNEL4_OUTPORT = '8000'
CHANNEL4_FORMAT = 0

CHANNEL5_DESC = 'Default'
CHANNEL5_PREFIX = '/MonoLink'
CHANNEL5_INPORT = '10092'
CHANNEL5_OUTPORT = '10091'
CHANNEL5_FORMAT = 0

CHANNEL6_DESC = 'Default'
CHANNEL6_PREFIX = '/MonoLink'
CHANNEL6_INPORT = '10092'
CHANNEL6_OUTPORT = '10091'
CHANNEL6_FORMAT = 0

CHANNEL7_DESC = 'Default'
CHANNEL7_PREFIX = '/MonoLink'
CHANNEL7_INPORT = '10092'
CHANNEL7_OUTPORT = '10091'
CHANNEL7_FORMAT = 0

CHANNEL8_DESC = 'Default'
CHANNEL8_PREFIX = '/MonoLink'
CHANNEL8_INPORT = '10092'
CHANNEL8_OUTPORT = '10091'
CHANNEL8_FORMAT = 0

CHANNEL9_DESC = 'Default'
CHANNEL9_PREFIX = '/MonoLink'
CHANNEL9_INPORT = '10092'
CHANNEL9_OUTPORT = '10091'
CHANNEL9_FORMAT = 0

CHANNEL10_DESC = 'Default'
CHANNEL10_PREFIX = '/MonoLink'
CHANNEL10_INPORT = '10092'
CHANNEL10_OUTPORT = '10091'
CHANNEL10_FORMAT = 0

CHANNEL11_DESC = 'Default'
CHANNEL11_PREFIX = '/MonoLink'
CHANNEL11_INPORT = '10092'
CHANNEL11_OUTPORT = '10091'
CHANNEL11_FORMAT = 0

CHANNEL12_DESC = 'Default'
CHANNEL12_PREFIX = '/MonoLink'
CHANNEL12_INPORT = '10092'
CHANNEL12_OUTPORT = '10091'
CHANNEL12_FORMAT = 0

CHANNEL13_DESC = 'Default'
CHANNEL13_PREFIX = '/MonoLink'
CHANNEL13_INPORT = '10092'
CHANNEL13_OUTPORT = '10091'
CHANNEL13_FORMAT = 0

CHANNEL14_DESC = 'Default'
CHANNEL14_PREFIX = '/MonoLink'
CHANNEL14_INPORT = '10092'
CHANNEL14_OUTPORT = '10091'
CHANNEL14_FORMAT = 0

CHANNEL15_DESC = 'Default'
CHANNEL15_PREFIX = '/MonoLink'
CHANNEL15_INPORT = '10092'
CHANNEL15_OUTPORT = '10091'
CHANNEL15_FORMAT = 0

CHANNEL16_DESC = 'Default'
CHANNEL16_PREFIX = '/MonoLink'
CHANNEL16_INPORT = '10092'
CHANNEL16_OUTPORT = '10091'
CHANNEL16_FORMAT = 0

PRESETS = [[CHANNEL1_PREFIX, CHANNEL1_FORMAT, [CHANNEL1_INPORT, CHANNEL1_OUTPORT], CHANNEL1_DESC],
	[CHANNEL2_PREFIX, CHANNEL2_FORMAT, [CHANNEL2_INPORT, CHANNEL2_OUTPORT], CHANNEL2_DESC],
	[CHANNEL3_PREFIX, CHANNEL3_FORMAT, [CHANNEL3_INPORT, CHANNEL3_OUTPORT], CHANNEL3_DESC],
	[CHANNEL4_PREFIX, CHANNEL4_FORMAT, [CHANNEL4_INPORT, CHANNEL4_OUTPORT], CHANNEL4_DESC],
	[CHANNEL5_PREFIX, CHANNEL5_FORMAT, [CHANNEL5_INPORT, CHANNEL5_OUTPORT], CHANNEL5_DESC],
	[CHANNEL6_PREFIX, CHANNEL6_FORMAT, [CHANNEL6_INPORT, CHANNEL6_OUTPORT], CHANNEL6_DESC],
	[CHANNEL7_PREFIX, CHANNEL7_FORMAT, [CHANNEL7_INPORT, CHANNEL7_OUTPORT], CHANNEL7_DESC],
	[CHANNEL8_PREFIX, CHANNEL8_FORMAT, [CHANNEL8_INPORT, CHANNEL8_OUTPORT], CHANNEL8_DESC],
	[CHANNEL9_PREFIX, CHANNEL9_FORMAT, [CHANNEL9_INPORT, CHANNEL9_OUTPORT], CHANNEL9_DESC],
	[CHANNEL10_PREFIX, CHANNEL10_FORMAT, [CHANNEL10_INPORT, CHANNEL10_OUTPORT], CHANNEL10_DESC],
	[CHANNEL11_PREFIX, CHANNEL11_FORMAT, [CHANNEL11_INPORT, CHANNEL11_OUTPORT], CHANNEL11_DESC],
	[CHANNEL12_PREFIX, CHANNEL12_FORMAT, [CHANNEL12_INPORT, CHANNEL12_OUTPORT], CHANNEL12_DESC],
	[CHANNEL13_PREFIX, CHANNEL13_FORMAT, [CHANNEL13_INPORT, CHANNEL13_OUTPORT], CHANNEL13_DESC],
	[CHANNEL14_PREFIX, CHANNEL14_FORMAT, [CHANNEL14_INPORT, CHANNEL14_OUTPORT], CHANNEL14_DESC],
	[CHANNEL15_PREFIX, CHANNEL15_FORMAT, [CHANNEL15_INPORT, CHANNEL15_OUTPORT], CHANNEL15_DESC],
	[CHANNEL16_PREFIX, CHANNEL16_FORMAT, [CHANNEL16_INPORT, CHANNEL16_OUTPORT], CHANNEL16_DESC]]
